/***
 * Excerpted from "The ThoughtWorks Anthology 2",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/twa2 for more book information.
***/
class Student {
    List schedule = []
    def addLecture(String lecture) { schedule << lecture }
}
class Worker {
    List schedule = []
    def addMeeting(String meeting) { schedule << meeting }
}
def collegeStudent = new Object()
collegeStudent.metaClass {
    mixin Student, Worker
    getSchedule {
        mixedIn[Student].schedule + mixedIn[Worker].schedule
    }
}
collegeStudent.with {
    addMeeting('Performance review with Boss')
    addLecture('Learn about Groovy Mixins')
    println schedule 
    // [Learn about Groovy Mixins, Performance review with Boss]
}
